#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <signal.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#define MAX_STRING 512
#define FOREVER while(1)

int main(int argc, char *argv[ ])
{
	pid_t pid;
	int socket_fd;
	char get_string[MAX_STRING];
	int string_length;
	struct sockaddr_in server_address;

	if((socket_fd = socket(PF_INET, SOCK_STREAM, 0)) < 0)
		{
		perror("socket");
		exit(1);
		}

	bzero((char *)&server_address, sizeof(server_address));
	server_address.sin_family = AF_INET;
	server_address.sin_addr.s_addr = inet_addr("61.33.30.40");
	server_address.sin_port = htons(3000);

	if(connect(socket_fd,
		(struct sockaddr *) &server_address,sizeof(server_address)) < 0)
		{
		perror("connect");
		exit(1);
		}

	puts("******************");
	puts(" Ǿ.");
	puts("******************");

	if((pid = fork( )) > 0)
		{
		while(fgets(get_string, MAX_STRING, stdin) != NULL)
			{
			string_length = strlen(get_string);
			if(write(socket_fd, 
				get_string, string_length) != string_length)
				perror("write");
			if(!strcmp(get_string, "exit\n"))
				{
				puts("Ŭ̾Ʈ û  .");
				close(socket_fd);
				exit(0);
				}
			}
		} /* if((pid = fork( )) > 0) */
	else if(pid == 0)
	{
		FOREVER
			{
			if((string_length = read(socket_fd, 
				get_string, MAX_STRING)) < 0)
				{
				puts("  .");
				close(socket_fd);
				exit(0);
				}
			get_string[string_length] =  '\0';
			printf("[server] %s", get_string);
			if (!strcmp(get_string, "exit\n"))
				{
				puts(" û  .");
				close(socket_fd);
				exit(1);
				}
			} /* while */
	} /* else if(pid == 0) */

	close(socket_fd);
}
