#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <signal.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#define MAX_STRING 512
#define FOREVER while(1)

int main(int argc, char *argv[ ])
{
	pid_t pid;
	int server_socket, client_socket;
	int string_length;
	char get_string[MAX_STRING];
	struct sockaddr_in client_address, server_address;


	if((server_socket = socket(PF_INET, SOCK_STREAM, 0)) < 0)
	{
	perror("socket");
	exit(0);
	}

	bzero((char *)&server_address, sizeof(server_address));
	server_address.sin_family = PF_INET;
	server_address.sin_addr.s_addr = htonl(INADDR_ANY);
	server_address.sin_port = htons(3000);

	if(bind(server_socket,
	(struct sockaddr *)&server_address, sizeof(server_address)) < 0)
		{
		perror("bind");
		exit(1);
		}

	puts("server ready");

	listen(server_socket, 5);

	string_length = sizeof(client_address);
	if((client_socket = accept(server_socket, NULL, NULL)) < 0)
		{
		perror("accept");
		exit(1);
		}

	puts("************************");
	puts("Ŭ̾Ʈ Ǿ.");
	puts("************************");


	/* θ μ */
	if((pid = fork( )) > 0)
		{
		while(fgets(get_string, MAX_STRING, stdin) != NULL)
			{
			string_length = strlen(get_string);
			if(write(client_socket,
			get_string, string_length) != string_length)
			perror("write");

			if(!strcmp(get_string, "exit\n"))
				{
				close(client_socket);
				exit(0);
				}
			}
		} /* if((pid = fork( )) > 0) */
		/* ڽ μ */
	else	if (pid == 0)
	{
		FOREVER 
		{
		if((string_length = read(client_socket, 
			get_string, MAX_STRING)) < 0)
			{
			puts("Ŭ̾Ʈ  .");
			close(client_socket);
			exit(1);
			}
		get_string[string_length] =  '\0';
		printf("[client] %s", get_string);
		if (!strcmp(get_string, "exit\n"))
			{
			puts("Ŭ̾Ʈ  .");
			close(client_socket);
			exit(1);
			}
		} /* FOREVER */
	} /* if(pid == 0) */

	close(server_socket);
	close(client_socket);
}
