#include <unistd.h>

void itoa(int, char *);

main()
{
	int		PIPE[2];
	char	child_pid[20];
	char	buf[1024];


	pipe(PIPE);
	if(fork() == 0)	// child
	{
		close(PIPE[0]);
		itoa((int)getpid(), child_pid);
		write(PIPE[1], child_pid, strlen(child_pid) + 1);
		exit(0);
	}

	close(PIPE[1]);
	wait();

	read(PIPE[0], buf, 1024);
	printf("%s\n", buf);
}

void
itoa(int number, char *imsi)
{
	int		i = 0;
	int		count;
	char	temp[20];


	for(;number;)
		{
		temp[i] = (number % 10) + '0';
		number /= 10;
		i++;
		}

	temp[i] = '\0';

	count = i;
	for(i = 0;i < count;i++)
		imsi[i] = temp[count - (i + 1)]; 

	imsi[i] = '\0';


}
