#include <stdio.h>
#include <fcntl.h>
#include <dirent.h>

main(int argc, char *argv[])
{
	void    fatal(char *);
	int     fd;
	DIR     *dir;
	struct  dirent  *directory;


	if(argc != 2)
		{
		puts(" : a.out directory_name");
		exit(0);
		}

	if((dir = opendir(argv[1])) == NULL)
		fatal("opendir");

	while(directory = readdir(dir))
		{
		if(directory->d_ino == 0)
			continue;
		printf("%s\t", directory->d_name);
		}

	closedir(dir);
}

void
fatal(char *error_name)
{
	perror(error_name);
	exit(1);
}
