#include <stdio.h>
#include <kstat.h>

main()
{
	void		fatal(char *);
	kstat_t		*ks;
	kstat_ctl_t	*kc;
	kstat_named_t	*kn;

	if((kc = kstat_open()) < 0)
		fatal("kstat_open");

	ks = kstat_lookup(kc, "unix", 0, "system_misc");
	if(kstat_read(kc, ks, 0) < 0)
		fatal("kstat_read");
	kn = kstat_data_lookup(ks, "avenrun_1min");
	printf("average 1 min : %d\n", kn->value.ui32);
	kn = kstat_data_lookup(ks, "avenrun_5min");
	printf("average 5 min : %d\n", kn->value.ui32);
	kn = kstat_data_lookup(ks, "avenrun_15min");
	printf("average 15 min : %d\n", kn->value.ui32);
	kn = kstat_data_lookup(ks, "nproc");
	printf("total process : %d\n", kn->value.ui32);
	
}

void
fatal(char *error_name)
{
	perror(error_name);
	exit(0);
}
