#include <stdio.h>
#include <dirent.h>
#include <sys/stat.h>

main(int argc, char *argv[ ])
{
	void check_match(DIR  *, char *, char *);
	void fatal(char *);
	char path_name[BUFSIZ];
	struct stat source_stat;
	DIR  *dir;
	
	if(argc < 3)
		{
		puts(" : % a.out directory_name pattern");
		exit(0);
		}

	if(stat(argv[1], &source_stat) < 0)
		fatal("source stat");

	// 丮 ƴϸ 
	if(!S_ISDIR(source_stat.st_mode & S_IFMT))
		{
		printf("%s is not directory\n", argv[1]);
		exit(0);
		}

	// 丮 .
	if((dir = opendir(argv[1])) == NULL)
		fatal("opendir");

	strcpy(path_name, argv[1]);
	check_match(dir, argv[argc - 1], path_name);
	}

void
check_match(DIR *dir, char *pattern, char *path_name)
{
	void fatal(char *);
	struct dirent *directory;
	struct stat file_stat;
	char path_name_buff[BUFSIZ];

	// 丮 д´.
	while(directory = readdir(dir))
		{
		if(!strncmp(directory->d_name, ".", 1))
			continue;
		if(directory->d_ino == 0)
			continue;
		sprintf(path_name_buff, "%s/%s", path_name, directory->d_name);
		
		if(stat(path_name_buff, &file_stat) < 0)
			fatal("stat");

		//  丮  ٸ 丮 ߰Ѵ.
		if(S_ISDIR(file_stat.st_mode & S_IFMT))
			{
			DIR *imsi_dir;
			if((imsi_dir = opendir(directory->d_name)) < 0)
				fatal("opendir");
			check_match(imsi_dir, pattern, path_name_buff);
			}

			// ϰ ġϸ Ѵ.
			if(!strcmp(directory->d_name, pattern))
				puts(path_name_buff);
		}

	closedir(dir);
}
void
fatal(char *error_name)
{
	perror(error_name);
	exit(1);
}
